#pragma once

#include <memory>
#include <functional>
#include "NamedPipe.h"


class DataExportSocket
{
public:
    DataExportSocket();

    void sendRequest(const std::string& ipAddr, const std::string& httpHeader);

private:
    std::unique_ptr<UnixSocket> mSocket;
};


class DataImportServerConnection
{
public:
    DataImportServerConnection(std::unique_ptr<UnixSocket> socket);

    void initConnection();

    void receiveRequest(std::string& outIpAddr, std::string& outHttpHeader);

private:
    std::unique_ptr<UnixSocket> mSocket;
};


class DataImportServerSocket 
{
public:
    DataImportServerSocket();

    class Request
    {
    public:
        std::string httpHeader;
    };

    std::unique_ptr<DataImportServerConnection> acceptConnection();

private:
    std::unique_ptr<UnixSocket> mSocket;
};