#include <iostream>
#include <string>
#include <errno.h>

#define unique_ptr auto_ptr

#include "DataExportPipe.h"

#include "DataExportPipe.cpp"
#include "NamedPipe.cpp"

using namespace std;


int main()
{
    try
    {
        cout << "Starting.\n";
        DataImportServerSocket socket;
        cout << "Created server socket.\n";
        
        string headers;
        for (;;)
        {
            try
            {
                cout << "Waiting for connection...\n";
                unique_ptr<DataImportServerConnection> connection = socket.acceptConnection();
                cout << "Got connection to client.\n";

                connection->initConnection();

                try
                {
                    string data;
                    connection->receiveRequest(data);
                    cout << "Got data: " << data << "\n";
                }
                catch (UnixSocketClosedException&)
                {
                    cout << "Connection closed.\n\n";
                }                
                catch (exception& exc)
                {
                    cout << "Error reading from connection: " << exc.what() << "\n";
                }

                cout << "\n";
            }
            catch (exception& exc)
            {
                cout << "Error accepting connection: " << exc.what() << "\n";
            }
        }
    }
    catch (exception& exc)
    {
        cout << "ERROR: " << exc.what() << endl;
    }

    return 0;
}